---
title: doc-utils
layout: main.html
---

# doc-utils {#-}

Documentation for the `doc-utils` projects.

The [docs2website] project is a static site generator primarily focused on technical writing and documentation. It is the main culmination of all of the other projects here, and is probably what you want if you're here to create a website of some kind.

The [color-themes] project contains the directory of all of the built-in color themes that come with [docs2website], and is where the JSON Schema and TypeScript definitions for those color themes are located.

The remaining projects each are responsible for converting one document format into another; [markdown2html] is an extension layer on top of [Marked] that is responsible for rendering Markdown to HTML, and the others all convert various formats into Markdown.

```pikchr
JSCH:   box "JSON Schema" wid 150% ht 65%

OAPI:   box "OpenAPI Spec" same \
          at 0.75 south of JSCH

CSBOM:  box "CycloneDX SBOM" same \
          at 0.75 south of OAPI

LD:     box "L-D Context" same \
          at 0.75 south of CSBOM

ETC:    box "Etc..." same \
          at 0.75 south of LD

MD:     box "Markdown" same \
          at 2.5 east of CSBOM

HTML:   box "HTML Fragments" same \
          at 2.5 east of MD

COLOR:  box "Color Themes" same \
          at 0.75 north of HTML

ASSET:  box "Static Assets" same \
          at 0.75 south of HTML

WEB:    box "Static Website" same \
          at 1.5 east of HTML

SITE:   box ht (COLOR.n.y-ASSET.s.y)+0.5 wid COLOR.wid+WEB.wid+0.75 \
          at (HTML.x+0.75,HTML.y) \
          dashed \
          behind HTML

text "docs2website" italic small above at SITE.s

arrow from JSCH .e to MD .nw \
  "jsonschema2markdown" italic aligned above small

arrow from OAPI .e to 0.1 above MD .w \
  "openapi2markdown" italic aligned above small

arrow from CSBOM .e to MD .w \
  "cyclonedxsbom2markdown" italic aligned above small

arrow from LD .e to 0.1 below MD .w \
  "ldcontext2markdown" italic aligned above small

arrow from ETC .e to MD .sw

arrow from MD .e to HTML .w \
  "markdown2html" italic aligned above small

arrow from COLOR .e to WEB .nw

arrow from HTML .e to WEB .w

arrow from ASSET .e to WEB .sw
```



## Projects

- [docs2website] - Static site generator based on an extended form of Markdown
- [color-themes] - Directory of color themes, along with the definition for the color theme format
- [markdown2html] - Convert Markdown documents to HTML documents
- [openapi2markdown] - Convert OpenAPI Specification files to Markdown documents
- [jsonschema2markdown] - Convert JSON Schema files to Markdown documents



## Markdown Format

See [Markdown Format]





<!-- Link Details -->

[docs2website]: ./docs2website/index.html
[color-themes]: ./color-themes/index.html
[markdown2html]: ./markdown2html/index.html
[openapi2markdown]: ./openapi2markdown/index.html
[jsonschema2markdown]: ./jsonschema2markdown/index.html
[Markdown Format]: ./markdown-format.html
[Marked]: https://marked.js.org/
